#[macro_use] extern crate rocket;

use rocket::serde::{Deserialize};

pub mod telecom;

#[derive(Deserialize)]
#[serde(crate = "rocket::serde")]
pub struct Message<'r> {
    pub userid: &'r str,
    pub password: &'r str,
    pub mobile: &'r str,
    pub content: &'r str
}

#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_to_urlencoded() {
        let message = Message {
            userid: "123",
            password: "456",
            mobile: "18605120786",
            content: "Hello world!"
        };
        let s = format!("userId={}&password={}&mobile={}&content={}", message.userid, message.password, message.mobile, message.content); 
        assert_eq!(&s, rocket::http::RawStr::new(&s).percent_encode().as_str());
    }
    #[test]
    fn test_req() {
        telecom::send_msg("1","2","3","4");
    }
}
